package com.hotwj.platform.pay.service.impl;

import com.hotwj.platform.pay.domain.PayChannel;
import com.hotwj.platform.pay.domain.bo.PayChannelBo;
import com.hotwj.platform.pay.domain.vo.PayChannelVo;
import com.hotwj.platform.pay.mapper.PayChannelMapper;
import com.hotwj.platform.pay.service.IPayChannelService;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 支付渠道
 * Service业务层处理
 *
 * @author shihongwei
 * @date 2026-05-08
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class PayChannelServiceImpl implements IPayChannelService {

    private final PayChannelMapper baseMapper;

    /**
     * 查询支付渠道
     *
     * @param id 主键
     * @return 支付渠道
     */
    @Override
    public PayChannelVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询支付渠道
     * 列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 支付渠道
     * 分页列表
     */
    @Override
    public TableDataInfo<PayChannelVo> queryPageList(PayChannelBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PayChannel> lqw = buildQueryWrapper(bo);
        Page<PayChannelVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的支付渠道
     * 列表
     *
     * @param bo 查询条件
     * @return 支付渠道
     * 列表
     */
    @Override
    public List<PayChannelVo> queryList(PayChannelBo bo) {
        LambdaQueryWrapper<PayChannel> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PayChannel> buildQueryWrapper(PayChannelBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PayChannel> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(PayChannel::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getCode()), PayChannel::getCode, bo.getCode());
        lqw.eq(bo.getStatus() != null, PayChannel::getStatus, bo.getStatus());
        lqw.eq(bo.getAppId() != null, PayChannel::getAppId, bo.getAppId());
        lqw.eq(StringUtils.isNotBlank(bo.getConfig()), PayChannel::getConfig, bo.getConfig());
        lqw.like(StringUtils.isNotBlank(bo.getCreateByName()), PayChannel::getCreateByName, bo.getCreateByName());
        lqw.like(StringUtils.isNotBlank(bo.getUpdateByName()), PayChannel::getUpdateByName, bo.getUpdateByName());
        lqw.eq(bo.getIsDeleted() != null, PayChannel::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增支付渠道
     *
     * @param bo 支付渠道
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(PayChannelBo bo) {
        PayChannel add = MapstructUtils.convert(bo, PayChannel.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改支付渠道
     *
     * @param bo 支付渠道
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(PayChannelBo bo) {
        PayChannel update = MapstructUtils.convert(bo, PayChannel.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PayChannel entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除支付渠道
     * 信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
